package api1.route;

import api1.processor.ApiProcessor;
import org.apache.camel.builder.RouteBuilder;

/**
 * @author Airhead
 * @since 2016-11-13
 */
public class ApiRouteBulider extends RouteBuilder {
    @Override
    public void configure() throws Exception {
        from("jetty:http://localhost:9091/api/v1").routeId("api1")
                .process(new ApiProcessor()).to("stream:out");
    }
}
